// DNDToolbars.java

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;

class DNDToolbars extends JFrame
{
   JToolBar tb;

   DNDToolbars (String title)
   {
      // Pass the title argument to the JFrame superclass so that the
      // contents of title appear in the JFrame's title bar.

      super (title);

      // Exit the application by calling System.exit when the user 
      // either selects Close from the System menu or clicks the X 
      // button.

      setDefaultCloseOperation (EXIT_ON_CLOSE);

      // Create an object from a subclass of AbstractAction and 
      // assign its reference to a1.  This is legal because 
      // AbstractAction implements Action.  As a result, the object 
      // is also an Action.  This action is executed if the user 
      // either selects Detachable from the menu or presses the 
      // toolbar's Detachable button.

      Action a1 = new AbstractAction ()
                      {
                         // This instance initializer assigns the
                         // action's name as soon as the object is
                         // created.

                         {
                            putValue (Action.NAME, "Detachable");
                         }

                         public void actionPerformed (ActionEvent e)
                         {
                            // Make the JToolBar detachable.

                            tb.setFloatable (true);
                        }
                     };

      // Create an object from a subclass of AbstractAction and assign
      // its reference to a1.  This is legal because AbstractAction
      // implements Action.  As a result, the object is also an 
      // Action.  This action is executed if the user either selects 
      // Non-Detachable from the menu or presses the toolbar's 
      // Non-Detachable button.

      Action a2 = new AbstractAction ()
                      {
                         // This instance initializer assigns the
                         // action's name as soon as the object is
                         // created.

                         {
                            putValue (Action.NAME, "Non-Detachable");
                         }

                         public void actionPerformed (ActionEvent e)
                         {
                            // Make the JToolBar non-detachable.

                            tb.setFloatable (false);
                         }
                     };

      // Create a file menu

      JMenu fileMenu = new JMenu ("File");

      // Create a "Detachable" menu item, assign a as this menu item's
      // action, and add the item to the File menu.

      JMenuItem mi = new JMenuItem ();
      mi.setAction (a1);
      fileMenu.add (mi);

      // Create a "Non-Detachable" menu item, assign a as this menu 
      // items action, and add the item to the File menu.

      mi = new JMenuItem ("Non-Detachable");
      mi.setAction (a2);
      fileMenu.add (mi);

      // Create a menu bar and add the File menu to this menu bar.

      JMenuBar mb = new JMenuBar ();
      mb.add (fileMenu);

      // Establish the menu bar as this program's menu bar.

      setJMenuBar (mb);

      // Create the JToolBar.

      tb = new JToolBar ();

      // Create and add "Detachable" JButton to the JToolBar.

      JButton b = new JButton ();
      b.setAction (a1);
      tb.add (b);

      // Create and add "Non-Detachable" JButton to the JToolBar.

      b = new JButton ();
      b.setAction (a2);
      tb.add (b);

      // Place the JToolBar in a JPanel to give it a more natural size.

      JPanel p = new JPanel ();
      p.setLayout (new BorderLayout ());
      p.add (tb, BorderLayout.WEST);

      // Add the JPanel to the North region of the JFrame's content 
      // pane.

      getContentPane ().add (p, BorderLayout.NORTH);

      // Set the size of the JFrame window.

      setSize (350, 150);

      // Show the JFrame window.

      setVisible (true);
   }

   public static void main (String [] args)
   {
      new DNDToolbars ("Detachable/Non-Detachable Toolbars");
   }
}
